with Flts;
use Flts;

pragma Elaborate_all (Flts);

generic

  type Scalar is private;

  with procedure Copy(S1: in Scalar; S2: in out Scalar) is <>;
  with procedure Sum(S1,S2: in Scalar; S3: in out Scalar) is <>;
  with procedure Mult(R: in Flt; S: in out Scalar) is <>;

package Bisect is --- find approximate zeros of functions

  generic
    with function F(X: Scalar) return Flt;
  procedure FindZero(XN,XP: in out Scalar; Err: in out Radius); -- assuming F(XN)<0, F(XP)>0

  Not_Found: exception;
  NFind: Positive := 512; -- max number of bisections in FindZero

end Bisect;
