with Ada.Text_IO, Strings, Ints, Flts, Globals, Reps.Balls, Params;
use Ada.Text_IO, Strings, Ints, Flts, Globals, Reps.Balls, Params;
with Params.Names,Matrices,Vectors,ScalVectors,Cylinders,Cylinders.Fix;

pragma Elaborate_All (Ada.Text_IO,Strings,Ints,Flts,Globals,Reps.Balls);
pragma Elaborate_All (Cylinders,Cylinders.Fix);

procedure Check_FixPt(P: in Param) is

   package PN is new Params.Names(P => P, Trunc => False);
   use PN;

   subtype Scalar is Ball;

   package SM is new Matrices (Scalar => Scalar);
   package SV is new Vectors (Component => Scalar);
   package SSV is new ScalVectors(Scalar => Scalar, SM => SM, SV => SV);

   package Cyls is new Cylinders(DegX => DegX, DegY => DegY, LDeg => LDeg, WFac => WFac, RadX => RadX,
                                 EllR => EllR, Scalar => Scalar, SM => SM, SV => SV, Ref => Ref, Symm => Symm);
   package Fix is new Cyls.Fix(Mat_PackSize => Mat_PackSize, NN => NN, RR => RR, Map => Map, SSV => SSV);

   use Cyls,Fix,Cyls.Cyl;

   F: Cylinder;
   M: QC_Matrix;

begin

   Read(Input_Dir & Fix_Name & ".approx",F);
   if Map=6 then Near_Cassini_Injective(RR); end if;
   SM.Read(Input_Dir & Mat_Name,M);
   ContrFix(M,Contr_Packsize,F);
   Show1("Norm F",MaxNorm(F));
   Write(Output_Dir & Fix_Name,F);

end Check_FixPt;
