with BigRats, Flts;
use Flts;

pragma Elaborate_All (BigRats,Flts);

generic

  NMax: in Positive; --- no prime factors larger than this

  type Scalar is private;

  with procedure Mult(S1: in Scalar; S2: in out Scalar) is <>;
  with procedure Quot(S1,S2: in Scalar; S3: in out Scalar) is <>;
  with procedure Assign(K: in Integer; S: in out Scalar) is <>;
  with procedure Mult(R: in Flt; S,Tmp: in out Scalar) is <>;
  with procedure IPower(I: in Integer; S1: in Scalar; S2,Tmp: in out Scalar) is <>;

package Comb is --- combinatorial factor for Near_Cassini

  package Rats is new BigRats (NMax => NMax); --- was used for 3j symbols
  use Rats;

  type Scalar_Vector is array (Integer range <>) of Scalar;

  procedure AbsChoose(P: in Integer; Q: in Positive; C: in out Scalar_Vector); --- |{P/Q choose N}|
  function AbsChoose(P: Integer; Q: Positive; LMax: Natural) return Scalar_Vector;

  Be_Serious: exception;

private

  IntegerLast: constant Flt := Two**64;

  procedure Int_Mult(B: in BigRat; S,Tmp3,Tmp4,Tmp5: in out Scalar);

end Comb;
