
package body CpWeights is

  function CpWeight(WFac,WPow: Radius; I: Natural) return Radius is
    --- using that Flt ops are being rounded up
  begin
    if WPow=Zero or else WFac=Zero or else I=0 then return One; end if;
    declare
      R: constant Radius := One+WFac*Flt(I);
      use Flt_EF;
    begin
      if WPow=One then return R; end if;
      return Exp(WPow*Log(R));
    end;
  end CpWeight;

  function CpWeight(WFac,WPow: Radius; Last: Positive) return FltVec is
    W: FltVec(0 .. Last);
  begin
    if WPow=Zero or else WFac=Zero then
      W := (others => One);
    else
      for I in W'Range loop
        W(I) := CpWeight(WFac,WPow,I);
      end loop;
    end if;
    return W;
  end CpWeight;

  function InvCpWeight(WFac,WPow: Radius; I: Natural) return Radius is
    --- using that Flt ops are being rounded up
  begin
    if WPow=Zero or else WFac=Zero or else I=0 then return One; end if;
    declare
      R: constant Radius := NegOne/(NegOne+WFac*Flt(-I));
      use Flt_EF;
    begin
      if WPow=One then return R; end if;
      return Exp(WPow*Log(R));
    end;
  end InvCpWeight;

  function InvCpWeight(WFac,WPow: Radius; Last: Positive) return FltVec is
    --- using that Flt ops are being rounded up
    W: FltVec(0 .. Last);
  begin
    if WPow=Zero or else WFac=Zero then
      W := (others => One);
    else
      for I in W'Range loop
        W(I) := InvCpWeight(WFac,WPow,I);
      end loop;
    end if;
    return W;
  end InvCpWeight;

end CpWeights;
