
package Flts.Complexs is --- very basic

  type Complex is
    record
      Re: Flt;
      Im: Flt;
    end record;

  CZero: constant Complex := (Zero,Zero);
  COne:  constant Complex := (One,Zero);
  CImag: constant Complex := (Zero,One);

  function "-"(Z: Complex) return Complex;
  function "+"(Z1,Z2: Complex) return Complex;
  function "-"(Z1,Z2: Complex) return Complex;
  function "*"(R: Flt; Z: Complex) return Complex;
  function "*"(Z1,Z2: Complex) return Complex;
  function "/"(R: Flt; Z: Complex) return Complex;
  function "/"(Z: Complex; R: Flt) return Complex;
  function "/"(Z1,Z2: Complex) return Complex;
  function "**"(Z: Complex; I: Integer) return Complex;
  function "abs"(Z: Complex) return Flt;

  function Adjoint(Z: Complex) return Complex;
  function Sqrt(Z: Complex) return Complex;
  function Exp(Z: Complex) return Complex;
  procedure Polar(X,Y: in Flt; Rad,Phi: out Flt);
  function Log(Z: Complex) return Complex;

end Flts.Complexs;
