with Flts, Reps, Vectors, Polynoms, Polynoms.Soil;
use Flts, Reps;

pragma Elaborate_All (Flts,Reps,Vectors,Polynoms.Soil);

package Num_Polynoms is

  subtype Numeric is Rep;
  package NV is new Vectors (Component => Numeric);
  subtype NVector is NV.Vector;
  package NP is new Polynoms (Scalar => Numeric, SV => NV);
  subtype NPolynom1 is NP.Polynom1;
  package NP_Soil is new NP.Soil;

  --- these pass data via Get_Numeric, Put_Numeric
  procedure NumRealRoot(Deg: in Positive; WMin,WMax: in Flt; Eps: in Radius);
  procedure NumRealRoots(Deg: in Positive; WMin,WMax: in Flt; Eps: in Radius);
  procedure NumSymQFactor(Deg: in Positive; UMin,UMax: in Flt; Eps: in Radius);
  procedure NumRoots(D: in out Natural);

  NFind: Positive renames NP_Soil.Bis.NFind;

private

  procedure NumRoots(P: in NPolynom1; Wr,Wi: in out NVector; D: out Natural); -- Jenkins & Traub, then Newton

end Num_Polynoms;
