with Strings;
use Strings ;

pragma Elaborate_All (Strings);

generic

   P: in Param;
   Trunc: in Boolean;

package Params.Names is

   Prefix: String renames P.Prefix;
   Map:  Positive renames P.Map;
   DegX: Positive renames P.DegX;
   DegY: Positive renames P.DegY;
   LDeg: Natural renames P.LDeg;
   WFac: Radius renames P.WFac;
   RadX: Radius renames P.RadX;
   EllR: Radius renames P.EllR;
   NN:   Integer renames P.NN;
   RR:   Radius renames P.RR;
   Ref:  MinusOneZeroOne renames P.Ref;
   Symm: Natural renames P.Symm;
   Mat_PackSize: Positive renames P.Mat_PackSize;
   Contr_PackSize: Natural renames P.Contr_PackSize;

   Post: constant String := Choose(Trunc,".approx","");
   Mat_Name: constant String := Prefix & "-mat." & Strng0(Mat_PackSize,3);
   Fix_Name: constant String := Prefix & "-fix" & Post;
   Plot_Name: constant String := Prefix & ".plot";
   Eigen_Name: constant String := Prefix & ".eigen";

end Params.Names;
