with Globals, Ints, Strings, Params, Flts, Ints;
use Globals, Ints, Strings, Params, Flts, Ints;
with Approx_Fixpt,Approx_Morse,Check_Fixpt,Num_Extrema,Check_Misc;

pragma Elaborate_All (Globals,Ints,Strings,Approx_Fixpt,Check_Fixpt,Num_Extrema,Check_Misc);

procedure Run_All is

   NT:   constant Positive := GetArg;      --- number of concurrent tasks
   Filename: constant String := GetArg;
   Sol:  constant Natural  := IndexOf(Filename);

   procedure Run(I: Natural) is
      P: Param := PList(I);
   begin
      Show1("PList entry ",I);
      Approx_Fixpt(P);
      Show0("Approx_Fixpt done");
      if P.Contr_PackSize>0 then
         Check_Fixpt(P);
         Show0("Check_Fixpt done");
         if I>1 then
            Num_Extrema(P);
            Check_Misc(P);
         end if;
      end if;
      Show0("--------------------------------");
      Approx_Morse(P);
   end Run;

   PP: Param := PList(Sol);

begin

   Verbosity := 0;
   NTasks := NT;

   if Sol>0 then
      Run(Sol);
   else
      for I in 1..PList'Last loop Run(I); end loop;
   end if;

end Run_All;
