with Globals;
use Globals;

pragma Elaborate_All (Globals);

package body Vectors.More is

  procedure Min(V: in Vector; S: in out Component) is
  begin
    for N in V'Range loop Min(V(N),S); end loop;
  end Min;

  procedure Max(V: in Vector; S: in out Component) is
  begin
    for N in V'Range loop Max(V(N),S); end loop;
  end Max;

  function Sup(V: Vector) return Flt is
    R: Flt := Sup(V(V'First));
  begin
    for N in V'First+1 .. V'Last loop
      R := RMax(Sup(V(N)),R);
    end loop;
    return R;
  end Sup;

  function Inf(V: Vector) return Flt is
    R: Flt := Inf(V(V'First));
  begin
    for N in V'First+1 .. V'Last loop
      R := RMin(Inf(V(N)),R);
    end loop;
    return R;
  end Inf;

end Vectors.More;
