with Logicals, Flts;
use Logicals, Flts;

pragma Elaborate_All (Logicals,Flts);

generic

  with function IsSharp(S: Component) return Boolean is <>;
  with function Center0(S: Component) return Boolean is <>;
  with function Contains0(S: Component) return Logical is <>;
  with function Contains(S1,S2: Component) return Logical is <>;
  with procedure ToErr(S: in out Component) is <>;
  with procedure ToErr(S1: in Component; S2: in out Component) is <>;
  with procedure Center(S: in out Component) is <>;
  with procedure Center(S1: in Component; S2: in out Component) is <>;
  with procedure ModCenter(S: in out Component) is <>;
  with procedure ModCenter(S1: in Component; S2: in out Component) is <>;
  with procedure Union(S1: in Component; S2: in out Component) is <>;
  with procedure Min(S1: in Component; S2: in out Component) is <>;
  with procedure Max(S1: in Component; S2: in out Component) is <>;
  with function Inf(S: Component) return Flt is <>;
  with function Sup(S: Component) return Flt is <>;

package Vectors.More is

  function IsSharp is new VF_BProperty (Component,Vector,IsSharp);
  function Center0 is new VF_BProperty (Component,Vector,Center0);
  function Contains0 is new VF_LProperty (Component,Vector,Contains0);
  function Contains is new VF_LSimilar (Component,Vector,Contains);
  procedure ToErr is new VP_Modify1 (Component,Vector,ToErr);
  procedure ToErr is new VP_Map1 (Component,Vector,ToErr);
  procedure Center is new VP_Modify1 (Component,Vector,Center);
  procedure Center is new VP_Map1 (Component,Vector,Center);
  procedure ModCenter is new VP_Modify1 (Component,Vector,ModCenter);
  procedure ModCenter is new VP_Map1 (Component,Vector,ModCenter);
  procedure Union is new VP_Map1 (Component,Vector,Union);

  procedure Min(V: in Vector; S: in out Component);
  procedure Max(V: in Vector; S: in out Component);
  function Sup(V: Vector) return Flt;
  function Inf(V: Vector) return Flt;

end Vectors.More;
